#!/usr/bin/python

from cgi import parse_qs
import urllib
import re
import time
import ssx

from caconf import *
from cadb import *

class CInfoSpacer:
	def __init__(self, cn):
		self.cn = cn
	def xml(self):
		return "<mgp:cert mode='spacer'>%s</mgp:cert>" % self.cn

def flatten(a2):
	res = []
	map(res.extend, a2)
	return res

def filter_group_by_cn(certs):
	res = {}
	for c in certs:
		if not res.has_key(c.cn):
			res[c.cn] = [CInfoSpacer(c.cn)]
		res[c.cn].append(c)
	return res.values()

def filter_group_by_dn(certs):
	res = {}
	for c in certs:
		if not res.has_key(c.dn):
			res[c.dn] = [CInfoSpacer(c.cn)]
		res[c.dn].append(c)
	return res.values()

def filter_nop(certs):
	return certs

def filter_search(certs, str):
	return filter(lambda x: x.match(str), certs)

from ssx import QueryObj, ssx_qs
class CQuery(QueryObj):
	def __init__(self, qs = None):
		self.qs = qs
		self.search = self.get("search", "")
		self.order = self.get("order", "none")
		self.group = self.get("group", "none")
		self.filter = self.get("filter", "valid")
	def xml(self):
		return """
<mgp:selector mode='cert' action='ca' search='%s'>
	<mgp:select name='filter' selected='%s'/>
<mgp:select name='group' selected='%s'/>
</mgp:selector>""" % (self.search, self.filter, self.group)

def comp(f0, f1):
	return lambda x: f1(f0(x))

def neg(x):
	return (not x)

def handler(req, xml, conf):
	cgi = ssx_qs(req.args)
	cq = CQuery(cgi)

	xml.data("<ssx:title>MGP: CA</ssx:title>\n")
	xml.push("ssx:center")
	xml.data("""
	Что такое simple-CA и с чем его едят?<br/>
	Этот и другие так волнующие Вас вопросы будут подробно рассмотрены на аудиенции у Шурега когда он проснется! 
	Следите за анонсами!<br/>
	А пока вы можете скачать <a href='ca/%s'>%s</a> и поставить себе simpleCA с клустерa следующими коммандами:
	<pre class='narrow'>gpt-build %s\ngpt-postinstall %s</pre>
	После этого необходимо выполнить комманду
	<pre class='narrow'>$GLOBUS_LOCATION/setup/%s/setup-gsi</pre>
	или, если нет прав системного администратора,
	<pre class='narrow'>$GLOBUS_LOCATION/setup/%s/setup-gsi -noroot</pre>
	""" % (cafile, cadist, cafile, cadist, cadist, cadist)) 
	xml.pop("ssx:center")
	xml.data("<hr/>")
	xml.data(cq.xml())
	xml.push("mgp:cert", "mode='list'")
	cfilter = filter_nop
	if cq.filter == "valid":
		cfilter = comp(cfilter, lambda x: filter(CInfo.valid, x))
	elif cq.filter == "invalid":
		cfilter = comp(cfilter, lambda x: filter(comp(CInfo.valid, neg), x))
	elif cq.filter == "expiring":
		cfilter = comp(cfilter, lambda x: filter(CInfo.expiring, x))
	elif cq.filter == "revoked":
		cfilter = comp(cfilter, lambda x: filter(CInfo.revoked, x))
	elif cq.filter == "all":
		pass
	if cq.search != '':
		cfilter = comp(cfilter, lambda x: filter_search(x, cq.search))
	if cq.group == "cn":
		cfilter = comp(cfilter, comp(filter_group_by_cn, flatten))
	elif cq.group == "dn":
		cfilter = comp(cfilter, comp(filter_group_by_dn, flatten))
	map(lambda x: xml.data(x.xml()), cfilter(certlist(caroot + "/index.txt")))
	xml.pop("mgp:cert")
	xml.data(cq.xml())
